#include <iostream>

using namespace std;


const int STATE_DISPLAY_MESSAGE_AND_CONTINUE       = 10;
const int STATE_DISPLAY_ERROR_MESSAGE_AND_CONTINUE = 20;
const int STATE_EXIT							   = 30;

void outputQuestion( )
{
	cout << "\nDo you want another greeting?\n"
	     << "Press y for yes, n for no, \n"
	     << "and then press return: ";
};

char readInput( )
{
	char ans=' ';
	cin >> ans;
	
	return ans;
}

int checkInput( char cInput )
{
	int nState;
	
	if( cInput=='n' || cInput == 'N')
	{
		nState  = STATE_EXIT;
	}
    else 
		if( cInput=='y' || cInput == 'Y')
		{
			nState  = STATE_DISPLAY_MESSAGE_AND_CONTINUE;
		}
		else 
		{
			nState  = STATE_DISPLAY_ERROR_MESSAGE_AND_CONTINUE;
		}
	
	return nState;
}


void outputMessage( int nState )
{
	if( nState == STATE_DISPLAY_MESSAGE_AND_CONTINUE )
		cout << "\nHello\n";
	else
		if ( nState == STATE_DISPLAY_ERROR_MESSAGE_AND_CONTINUE )
			cout << "\nYou have entered an invalid input\n";
	
}

void outputGoodBye( )
{
	cout << "\nGood-Bye\n";
}

int main( )
{
   char ans     = ' ';
   int nState   = STATE_DISPLAY_MESSAGE_AND_CONTINUE  ;

   do
   {
		outputMessage( nState );
		outputQuestion( );
		ans = readInput( );
		nState = checkInput( ans );

   } while( nState != STATE_EXIT  );

   outputGoodBye( );
   
   return 0;
}




